/*

Copyright (c) 2021 Ole-Christoffer Granmo

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

This code implements the Convolutional Tsetlin Machine from paper arXiv:1905.09688
https://arxiv.org/abs/1905.09688

*/

void produce_example_by_documents(
    unsigned int *active_output,
    int number_of_active_outputs,
    unsigned int *indptr_row,
    unsigned int *indices_row,
    int number_of_rows,
    unsigned int *indptr_col,
    unsigned int *indices_col,
    int number_of_cols,
    unsigned int *X,
    unsigned int *Y, 
    int accumulation,
    unsigned int *data_col,
    int categories,
    int random_per_category,
    int expert_start_index,
    int expert_end_index,
    int enable_log
);

void produce_example_per_target_by_document(
    unsigned int *active_output,
    int number_of_active_outputs,
    unsigned int *indptr_row,
    unsigned int *indices_row,
    int number_of_rows,
    unsigned int *indptr_col,
    unsigned int *indices_col,
    int number_of_cols,
    unsigned int *X,
    int target,
    int target_value,
    int accumulation
);

void tmu_encode(
    unsigned int *X,
    unsigned int *encoded_X,
    int number_of_examples,
    int dim_x,
    int dim_y,
    int dim_z,
    int patch_dim_x,
    int patch_dim_y,
    int append_negated,
    int class_features
);
